package org.dromara.shebei.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.personnel.domain.OpsBeipinBeijian;
import org.dromara.personnel.mapper.OpsBeipinBeijianMapper;
import org.dromara.shebei.domain.OpsSbMbBianliang;
import org.dromara.shebei.domain.dto.OpsSbLiebiaoDto;
import org.dromara.shebei.domain.vo.OpsSbMbBianliangVo;
import org.dromara.shebei.service.IOpsSbMbBianliangService;
import org.dromara.shebei.service.IOpsSbMobanService;
import org.springframework.stereotype.Service;
import org.dromara.shebei.domain.bo.OpsSbLiebiaoBo;
import org.dromara.shebei.domain.vo.OpsSbLiebiaoVo;
import org.dromara.shebei.domain.OpsSbLiebiao;
import org.dromara.shebei.mapper.OpsSbLiebiaoMapper;
import org.dromara.shebei.service.IOpsSbLiebiaoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-设备管理-设备列Service业务层处理
 *
 * @author LionLi
 * @date 2025-10-09
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsSbLiebiaoServiceImpl extends ServiceImpl<OpsSbLiebiaoMapper, OpsSbLiebiao> implements IOpsSbLiebiaoService {

    private final OpsSbLiebiaoMapper baseMapper;
    private final IOpsSbMbBianliangService mbBianliangService;

    /**
     * 查询运维-设备管理-设备列
     *
     * @param id 主键
     * @return 运维-设备管理-设备列
     */
    @Override
    public OpsSbLiebiaoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-设备管理-设备列列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-设备管理-设备列分页列表
     */
    @Override
    public TableDataInfo<OpsSbLiebiaoVo> queryPageList(OpsSbLiebiaoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsSbLiebiao> lqw = buildQueryWrapper(bo);
        Page<OpsSbLiebiaoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-设备管理-设备列列表
     *
     * @param bo 查询条件
     * @return 运维-设备管理-设备列列表
     */
    @Override
    public List<OpsSbLiebiaoVo> queryList(OpsSbLiebiaoBo bo) {
        LambdaQueryWrapper<OpsSbLiebiao> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsSbLiebiao> buildQueryWrapper(OpsSbLiebiaoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsSbLiebiao> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsSbLiebiao::getId);
        lqw.eq(bo.getProjectId() != null, OpsSbLiebiao::getProjectId, bo.getProjectId());
        lqw.like(StringUtils.isNotBlank(bo.getSbName()), OpsSbLiebiao::getSbName, bo.getSbName());
        lqw.eq(bo.getFileId() != null, OpsSbLiebiao::getFileId, bo.getFileId());
        lqw.eq(StringUtils.isNotBlank(bo.getFileUrl()), OpsSbLiebiao::getFileUrl, bo.getFileUrl());
        lqw.eq(StringUtils.isNotBlank(bo.getSn()), OpsSbLiebiao::getSn, bo.getSn());
        lqw.eq(StringUtils.isNotBlank(bo.getSbMiaoshu()), OpsSbLiebiao::getSbMiaoshu, bo.getSbMiaoshu());
        lqw.eq(StringUtils.isNotBlank(bo.getSbAdd()), OpsSbLiebiao::getSbAdd, bo.getSbAdd());
        lqw.eq(bo.getMbId() != null, OpsSbLiebiao::getMbId, bo.getMbId());
        lqw.eq(bo.getSlaveId() != null, OpsSbLiebiao::getSlaveId, bo.getSlaveId());
        lqw.eq(StringUtils.isNotBlank(bo.getSbStatus()), OpsSbLiebiao::getSbStatus, bo.getSbStatus());
        return lqw;
    }

    /**
     * 新增运维-设备管理-设备列
     *
     * @param bo 运维-设备管理-设备列
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsSbLiebiaoBo bo) {
        OpsSbLiebiao add = MapstructUtils.convert(bo, OpsSbLiebiao.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-设备管理-设备列
     *
     * @param bo 运维-设备管理-设备列
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsSbLiebiaoBo bo) {
        OpsSbLiebiao update = MapstructUtils.convert(bo, OpsSbLiebiao.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsSbLiebiao entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-设备管理-设备列信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public OpsSbLiebiaoDto getLiebiaoBianliangList(String snCode) {
        if (StrUtil.isBlank(snCode)) {
            return null;
        }
        OpsSbLiebiao opsSbLiebiao = baseMapper.selectOne(new LambdaQueryWrapper<OpsSbLiebiao>().eq(OpsSbLiebiao::getSn, snCode));
        if (opsSbLiebiao == null) {
            return null;
        }
        OpsSbLiebiaoDto opsSbLiebiaoDto = BeanUtil.copyProperties(opsSbLiebiao, OpsSbLiebiaoDto.class);
        List<OpsSbMbBianliang> opsSbMbBianliangs = mbBianliangService.getBaseMapper().selectList(new LambdaQueryWrapper<OpsSbMbBianliang>().eq(OpsSbMbBianliang::getMbId, opsSbLiebiaoDto.getMbId()));
        if (opsSbMbBianliangs != null && !opsSbMbBianliangs.isEmpty()) {
            List<OpsSbMbBianliangVo> opsSbMbBianliangVos = BeanUtil.copyToList(opsSbMbBianliangs, OpsSbMbBianliangVo.class);
            opsSbLiebiaoDto.setSbMbBianliangVos(opsSbMbBianliangVos);
        }
        return opsSbLiebiaoDto;
    }
}
